<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: PRD_OrdenDet.xml */
/* Generado: 2021-03-26 22:09:47 */

/* Mantenimiento de los registros de la tabla PRD_OrdenDet */
abstract class BasePRD_OrdenDetDP extends PRD_OrdenDetBV
{
    /* Constructor ( Establece los valores desde un objeto PRD_OrdenDetBN ) */
    public function __construct( PRD_OrdenDetBN $o_PRD_OrdenDetBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_PRD_OrdenDetBN ) )
        {
            $this->setByBN( $o_PRD_OrdenDetBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto PRD_OrdenDetBN */
    public function setByBN( PRD_OrdenDetBN $o_PRD_OrdenDetBN )
    {
        if ( !is_null( $o_PRD_OrdenDetBN->getIdOrdenDet() ) )
        {
            $this->setIdOrdenDet( $o_PRD_OrdenDetBN->getIdOrdenDet() );
        }
        if ( !is_null( $o_PRD_OrdenDetBN->getIdOrdenCab() ) )
        {
            $this->setIdOrdenCab( $o_PRD_OrdenDetBN->getIdOrdenCab() );
        }
        if ( !is_null( $o_PRD_OrdenDetBN->getIdItem() ) )
        {
            $this->setIdItem( $o_PRD_OrdenDetBN->getIdItem() );
        }
        if ( !is_null( $o_PRD_OrdenDetBN->getItemTipo() ) )
        {
            $this->setItemTipo( $o_PRD_OrdenDetBN->getItemTipo() );
        }
        if ( !is_null( $o_PRD_OrdenDetBN->getDescripcionItem() ) )
        {
            $this->setDescripcionItem( $o_PRD_OrdenDetBN->getDescripcionItem() );
        }
        if ( !is_null( $o_PRD_OrdenDetBN->getIdUnidad() ) )
        {
            $this->setIdUnidad( $o_PRD_OrdenDetBN->getIdUnidad() );
        }
        if ( !is_null( $o_PRD_OrdenDetBN->getCantidadPedida() ) )
        {
            $this->setCantidadPedida( $o_PRD_OrdenDetBN->getCantidadPedida() );
        }
        if ( !is_null( $o_PRD_OrdenDetBN->getCantidadRecibida() ) )
        {
            $this->setCantidadRecibida( $o_PRD_OrdenDetBN->getCantidadRecibida() );
        }
        if ( !is_null( $o_PRD_OrdenDetBN->getPrecioCostoUnit() ) )
        {
            $this->setPrecioCostoUnit( $o_PRD_OrdenDetBN->getPrecioCostoUnit() );
        }
        if ( !is_null( $o_PRD_OrdenDetBN->getPrecioCostoTotal() ) )
        {
            $this->setPrecioCostoTotal( $o_PRD_OrdenDetBN->getPrecioCostoTotal() );
        }
        if ( !is_null( $o_PRD_OrdenDetBN->getUsuarioCreacion() ) )
        {
            $this->setUsuarioCreacion( $o_PRD_OrdenDetBN->getUsuarioCreacion() );
        }
        if ( !is_null( $o_PRD_OrdenDetBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_PRD_OrdenDetBN->getFechaCreacion() );
        }
        if ( !is_null( $o_PRD_OrdenDetBN->getUsuarioModificacion() ) )
        {
            $this->setUsuarioModificacion( $o_PRD_OrdenDetBN->getUsuarioModificacion() );
        }
        if ( !is_null( $o_PRD_OrdenDetBN->getFechaModificacion() ) )
        {
            $this->setFechaModificacion( $o_PRD_OrdenDetBN->getFechaModificacion() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_PRD_OrdenDetFN = new PRD_OrdenDetFN();
        $o_PRD_OrdenDetBN = $o_PRD_OrdenDetFN->selectByPk( $this->getIdOrdenDet() );
        if ( is_null( $o_PRD_OrdenDetBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO PRD_OrdenDet ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getIdOrdenDet() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdOrdenDet";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdOrdenDet()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdOrdenCab() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdOrdenCab";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdOrdenCab()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdItem() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdItem";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdItem()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getItemTipo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ItemTipo";
                $s_SQLQuery2 .= $s_Separator."'".$this->getItemTipo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDescripcionItem() ) )
            {
                $s_SQLQuery1 .= $s_Separator."DescripcionItem";
                $s_SQLQuery2 .= $s_Separator."'".$this->getDescripcionItem()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdUnidad() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdUnidad";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdUnidad()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCantidadPedida() ) )
            {
                $s_SQLQuery1 .= $s_Separator."CantidadPedida";
                $s_SQLQuery2 .= $s_Separator."".$this->getCantidadPedida()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCantidadRecibida() ) )
            {
                $s_SQLQuery1 .= $s_Separator."CantidadRecibida";
                $s_SQLQuery2 .= $s_Separator."".$this->getCantidadRecibida()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioCostoUnit() ) )
            {
                $s_SQLQuery1 .= $s_Separator."PrecioCostoUnit";
                $s_SQLQuery2 .= $s_Separator."".$this->getPrecioCostoUnit()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioCostoTotal() ) )
            {
                $s_SQLQuery1 .= $s_Separator."PrecioCostoTotal";
                $s_SQLQuery2 .= $s_Separator."".$this->getPrecioCostoTotal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE PRD_OrdenDet SET ";
            $s_Separator = "";
            if ( !is_null( $this->getIdOrdenCab() ) )
            {
                $s_SQLQuery .= $s_Separator."IdOrdenCab = ".$this->getIdOrdenCab()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdItem() ) )
            {
                $s_SQLQuery .= $s_Separator."IdItem = '".$this->getIdItem()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getItemTipo() ) )
            {
                $s_SQLQuery .= $s_Separator."ItemTipo = '".$this->getItemTipo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDescripcionItem() ) )
            {
                $s_SQLQuery .= $s_Separator."DescripcionItem = '".$this->getDescripcionItem()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdUnidad() ) )
            {
                $s_SQLQuery .= $s_Separator."IdUnidad = ".$this->getIdUnidad()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCantidadPedida() ) )
            {
                $s_SQLQuery .= $s_Separator."CantidadPedida = ".$this->getCantidadPedida()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCantidadRecibida() ) )
            {
                $s_SQLQuery .= $s_Separator."CantidadRecibida = ".$this->getCantidadRecibida()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioCostoUnit() ) )
            {
                $s_SQLQuery .= $s_Separator."PrecioCostoUnit = ".$this->getPrecioCostoUnit()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioCostoTotal() ) )
            {
                $s_SQLQuery .= $s_Separator."PrecioCostoTotal = ".$this->getPrecioCostoTotal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioCreacion = '".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCreacion = '".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioModificacion = '".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaModificacion = '".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  IdOrdenDet = ".$this->getIdOrdenDet().";";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM PRD_OrdenDet WHERE  IdOrdenDet = ".$this->getIdOrdenDet().";";
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        return true;
    }

}
?>